<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Uberghey CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

$page_author = $creator_name;
$page_author_email = $creator_email;
$page_menu = 1;
$page_date = "30/10/2003, 20:39";
$page_title = i18n("File setup");

if (!auth($_REQUEST["username"], $_REQUEST["password"])) {
	$page_content = loginform($language, "./index.php?page_id=5&language=$language", $auth_messages);
} else if (isauth()) {
	//Manage files (images, downloads...)

	$page_content .= "
		<table  cellspacing=\"4\" class=\"setup\">
			<tr class=\"setup\">
			<td valign=\"top\" class=\"setup-header\" colspan=\"2\">
			<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
				<tr class=\"setup\">
				<td width=\"50%\">
					<div align=\"left\"><em>
					<a href=\"./index.php?page_id=3&amp;language=$language\">Setup</a>
					&gt;&gt; <a href=\"./index.php?page_id=11&amp;language=$language\">" . i18n("Files") . "</a></em></div>
				</td>
				<td>
					<div align=\"right\">
						<a class=\"command\" href=\"./index.php?page_id=11&action=upload&language=$language\">[" . i18n("Upload file") . "]</a>
					</div>
				</td>
				</tr>
			</table>
			</td>
			</tr>
			<tr class=\"setup\">
				<td>";
	if ($_REQUEST["action"] == "upload") {
		$page_content = "$page_content
		<p>" . i18n("Please select the file you wish to upload. Also, please note that you cannot upload files larger than 1 MB (1,048,576 bytes)") . "</p>
		<form enctype=\"multipart/form-data\" action=\"./index.php?page_id=11&action=uploadcomplete\" method=\"post\">
		<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"1048576\" />
		<div align=\"center\">
		<input name=\"uploadedfile\" type=\"file\" />
		<input type=\"submit\" value=\"" . i18n("Upload file") . "\" />
		</div>
		</form>
		";
	} else if ($_REQUEST["action"] == "uploadcomplete") {
		$uploadFile = $files_folder . "/" . $_FILES['uploadedfile']['name'];
		if (move_uploaded_file($_FILES['uploadedfile']['tmp_name'], $uploadFile))
		{
			chmod($uploadFile, 0664);// make sure the file is actually accessible...
			$page_content = "$page_content
			<p>" . i18n("The file has been uploaded.") . "</p>";
			header("Location: ./index.php?page_id=11&language=$language");
		} else {
			$page_content = "$page_content
			<p>" . i18n("The file could not be uploaded. The errormessage can be found bellow:") . "</p>
			<pre>";
			switch ($_FILES['uploadedfile']['error']) {
			case 1:
				$page_content = "$page_content The uploaded file exceeds the upload_max_filesize directive in php.ini.\nPlease contact your host and rectify this (or better yet, select a smaller file.\nMost often, this directive states 2MB as the maximum upload size, however as we have\n1MB as the maxium here, they have obviously changed it).</pre>";
				break;
			case 2:
				$page_content = "$page_content The uploaded file exceeds 1MB in size,\nand is too large to upload in this manner.</pre>";
				break;
			case 3:
				$page_content = "$page_content The uploaded file was only partially uploaded.</pre>";
				break;
			case 4:
				$page_content = "$page_content No file was uploaded.</pre>";
				break;
			}
		}
	} else if ($_REQUEST["edit_delete_confirm"] == "yes") {
		if (unlink("$files_folder/{$_REQUEST['filename']}")) {
			header("Location: ./index.php?page_id=11&language=$language");
		} else {
			$page_content = "$page_content
				<p>" . i18n("Deletion of the file could not be completed! Click your browser's &quot;Refresh&quot; button to try again, or ##0##click here##1## to return to the list of files.", array("<a href=\"./index.php?page_id=11&language=$language\">", "</a>")) . "</p>
			";
		}
	} else if ($_REQUEST["action"] == "delete") {
		$page_content = "$page_content
			<div align=\"center\">" . i18n("Please comfirm deletion of the file: ##0##", array($filename)) . "</div>
			<div align=\"center\">
			<a class=\"command\" href=\"./index.php?page_id=11&language=$language&edit_delete_confirm=yes&filename={$_REQUEST['filename']}\">[" . i18n("Confirm delete") . "]</a>
			<a class=\"command\" href=\"./index.php?page_id=11&language=$language\">[" . i18n("Abort delete") . "]</a></div>
		";
	} else if ($_REQUEST["action"] == "rename") {
		if (rename("$files_folder/{$_REQUEST['old_filename']}","$files_folder/{$_REQUEST['new_filename']}")) {
			$page_content = "$page_content
				<p>" . i18n("Renaming of the file was successfully completed.") . "</p>
			";
			header("Location: ./index.php?page_id=11&language=$language");
		} else {
			$page_content = "$page_content
				<p>" . i18n("Renaming of the file could not be completed! Please click your browser's &quot;Back&quot; button to return to the edit dialog, or the &quot;Refresh&quot; button to try again.") . "</p>
			";
		}
	} else if (!$_REQUEST["edit_filename"] == "") {
		$page_content = "$page_content
		<form action=\"./index.php?page_id=11&action=rename&language=$language\" method=\"post\">
		<input type=\"hidden\" name=\"old_filename\" value=\"{$_REQUEST["edit_filename"]}\" />
		<div align=\"center\">" . i18n("Type the new file name bellow") . "</div>
		<div align=\"center\"><input type=\"text\" value=\"{$_REQUEST["edit_filename"]}\" style=\"width: 80%;\" name=\"new_filename\" /></div>
		<br />
		<div align=\"center\">
			<input type=\"submit\" value=\"" . i18n("Save") . "\" />
			<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
		</div>
		</form>
		";
	} else {
		$page_content .= "
				<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
				<tr class=\"setup\">
				<th style=\"border-bottom: 1px solid gray;\">" . i18n("Filename") . "</th>
				<th style=\"border-bottom: 1px solid gray;\">" . i18n("Functions") . "</th>
				</tr>";
	
		$bgarray[1] = "transparent";
		$bgarray[2] = "#e0e0e0";
		$fp = opendir($files_folder);
		$array_index = 0;
		while ($file = readdir($fp)) {
			if ($file != "." && $file != "..") {
					$files_temp[] = $file;
			}
		}
		closedir($fp);
		if (!empty($files_temp)) {
			foreach($files_temp as $key => $value) {
				$bgarray = array_reverse($bgarray);
				$page_content .= "
				<tr>
					<td width=\"50%\" style=\"background-color: {$bgarray[1]}\"><div><a href=\"./index.php?page_id=11&edit_filename=$value&language=$language\">$value</a></div></td>
					<td style=\"background-color: {$bgarray[1]}\"><div align=\"right\"><a class=\"command\" href=\"./index.php?page_id=11&action=delete&filename=$value&language=$language\">[" . i18n("Delete") . "]</a></div></td>
				</tr>";
			}
		} else {
			$bgarray = array_reverse($bgarray);
			$page_content .= "
				<tr><td colspan=\"2\" style=\"background-color: {$bgarray[1]}\">
					<div>" . i18n("There are no files. ##0##[Click here to upload a file]##1##" , array("<a class=\"menutext\" href=\"./index.php?page_id=11&action=upload&language=$language\">", "</a>")) . "</div></td>
				</tr>";
		}
	}
	$page_content = "$page_content
			</td>
		</tr>
	</table>";
}
?>
