<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Uberghey CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

$page_author = $creator_name;
$page_author_email = $creator_email;
$page_menu = 1;
$page_date = "30/10/2003, 20:39";
$page_title = i18n("Menu setup");

if (!auth($_REQUEST["username"], $_REQUEST["password"])) {
	$page_content = loginform($language, "./index.php?page_id=5&language=$language", $auth_messages);
} else if (!isAllowed("global_menus")) {
	$page_content = "<p>" . i18n("You do not have the correct permissions to edit menus") . "</p>";
} else if (isauth()) {
	if ($_REQUEST["action"] == "assign") {
		if ($_REQUEST["action"] = "assign" && $_REQUEST["assign"]) {
			$assignto = $_REQUEST["pages"];
			if (is_array($assignto)) {
				global $page_folder;
				foreach($assignto as $key => $value) {
					$temp_page = $pagectl->fetchPageData($key, $value);
					$pagectl->savePageData($page_folder, $temp_page["id"], $temp_page["language"], $temp_page["author"], $temp_page["email"], $_REQUEST["menu_id"], $temp_page["title"], $temp_page["content"]);
				}
			}
			header("Location: ./index.php?page_id=7&language=$language");
		} else {
			$pages_temp = $pagectl->fetchPageList($page_folder);
			sort($pages_temp);
			$page_content = "$page_content
			<div align=\"center\">
				<form action=\"./index.php?page_id=7&amp;action=assign&amp;language=$language\" method=\"POST\">
				<input type=\"hidden\" name=\"menu_id\" value=\"{$_REQUEST["menu_id"]}\" />
				<table cellspacing=\"4\" width=\"90%\" style=\"border: 0;\">
					<tr class=\"setup\">
						<td>
						<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
						<tr class=\"setup\">
						<th style=\"border-bottom: 1px solid gray;\" width=\"8%\">" . i18n("ID") . "</th>
						<th style=\"border-bottom: 1px solid gray;\" width=\"12%\">" . i18n("Assign") . "</th>
						<th style=\"border-bottom: 1px solid gray;\">" . i18n("Title (click to edit)") . "</th>
						<th style=\"border-bottom: 1px solid gray;\" width=\"12%\">" . i18n("Language") . "</th>
						</tr>";
			
			$bgarray[1] = "transparent";
			$bgarray[2] = "#e0e0e0";
			foreach($pages_temp as $key => $value) {
				$bgarray = array_reverse($bgarray);
				$page_content = "$page_content
								<tr>
									<td style=\"background-color: {$bgarray[1]}\"><div>{$value["id"]}</div></td>
									<td style=\"background-color: {$bgarray[1]}\">";
				foreach ($value["title"] as $key2 => $value2) {
					$temp_page = $pagectl->fetchPageData($value["id"], $value["language"][$key2]);
					if ($temp_page["menu"] == $_REQUEST["menu_id"]) {
						$page_content = "$page_content<div><label><input type=\"checkbox\" disabled checked />" . i18n("Assign") . "</label></div>";
					} else {
						$page_content = "$page_content<div><label><input type=\"checkbox\" name=\"pages[{$value["id"]}]\" value=\"{$value["language"][$key2]}\" />" . i18n("Assign") . "</label></div>";
					}
				}
				$page_content = "$page_content
									</td>
									<td style=\"background-color: {$bgarray[1]}\">";
				foreach ($value["title"] as $key2 => $value2) {
					$page_content = "$page_content<div><a href=\"./index.php?page_id={$value["id"]}&language={$value['language'][$key2]}\">$value2</a></div>";
				}
				$page_content = "$page_content</td><td style=\"background-color: {$bgarray[1]}\">";
				foreach ($value["language"] as $key2 => $value2) {
					$page_content = "$page_content<div>[$value2]</div>";
				}
				$page_content = "$page_content</td></tr>";
			}
			$page_content = "$page_content
				</td></tr></table>
				</td></tr>
				<tr><td><div align=\"center\">
				<input type=\"submit\" name=\"assign\" value=\"" . i18n("Assign") . "\" />
				<input type=\"reset\" value=\"" . i18n("Reset changes") . "\" />
				</div></td></tr>
				</table></div>";
		}
	} else if ($_REQUEST["action"] == "delete" && $_REQUEST["menu_id"] != "") {
		global $setup_folder;
		if ($_REQUEST["confirm_delete"] == "true") {
			if (removeUsergroup("menu_" . $_REQUEST["menu_id"] . "_view") && removeUsergroup("menu_" . $_REQUEST["menu_id"] . "_edit")) {
				// get array $menufiles$fp = opendir("$setup_folder/modules");
				$fp = opendir("$setup_folder/menus");
				while ($file = readdir($fp)) {
					if (substr($file, 0, strlen("{$_REQUEST['menu_id']}.")) == "{$_REQUEST['menu_id']}.") $menufile[] ="$setup_folder/menus/$file";
				}
				closedir($fp);

				foreach ($menufile as $key => $value) {
					if (!unlink("$value")) {
						$page_content = "<p>" . i18n("An error occured during the removal of the menu files!") . "</p>";
					}
				}
				if ($page_content == "") header("./index.php?page_id=7&language=$language");
			} else {
				$page_content = "<p>" . i18n("An error occured during removal of the usergroups that are assigned to this menu!") . "</p>";
			}
		} else {
			$page_content = "
				<p>" . i18n("Please confirm that you wish to delete the menu with ID ##0##", array($_REQUEST['menu_id'])) . "</p>
				<p class=\"wikicenteralign\">
				<a href=\"./index.php?page_id=7&amp;language=$language&amp;action=delete&amp;menu_id={$_REQUEST['menu_id']}&amp;confirm_delete=true\" class=\"command\">[" . i18n("Confirm delete") . "]</a>
				<a href=\"./index.php?page_id=7&amp;language=$language\" class=\"command\">[" . i18n("Abort delete") . "]</a>
				</p>";
		}
	} else {
		$page_content = "$page_content
		<table cellspacing=\"4\" class=\"setup\">
			<tr class=\"setup\">
			<td valign=\"top\" class=\"setup-header\">
			<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
				<tr class=\"setup\">
				<td width=\"50%\">
					<div align=\"left\"><em>
					<a href=\"./index.php?page_id=3&amp;language=$language\">Setup</a>
					&gt;&gt; <a href=\"./index.php?page_id=7&amp;language=$language\">" . i18n("Menus") . "</a></em></div>
				</td>
				<td>
					<div align=\"right\">
						<a class=\"command\" href=\"./index.php?page_id=8&edit_title=" . rawurlencode(i18n("New menu")) . "&language=$language\">[" . i18n("New") . "]</a>
					</div>
				</td>
				</tr>
			</table>
			</td>
			</tr>
			<tr class=\"setup\">
				<td>
				<table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">
				<tr class=\"setup\">
				<th style=\"border-bottom: 1px solid gray;\" width=\"8%\">" . i18n("ID") . "</th>
				<th style=\"border-bottom: 1px solid gray;\">" . i18n("Title (click to edit)") . "</th>
				<th style=\"border-bottom: 1px solid gray;\" width=\"12%\">" . i18n("Language") . "</th>
				<th style=\"border-bottom: 1px solid gray;\" width=\"15%\">" . i18n("Functions") . "</th>
				</tr>";
	
		//Make the Menu menu sub-section
		$bgarray = array();
		$bgarray[1] = "transparent";
		$bgarray[2] = "#e0e0e0";
		$temp_menus = $pagectl->fetchMenuMenuList($menu_folder);
		foreach ($temp_menus as $key => $value) {
			if (is_array($value["language"])) {
				$page_content = "$page_content\n		<tr><td style=\"background-color: {$bgarray[1]};\"><div>{$value["id"]}</div></td><td style=\"background-color: {$bgarray[1]};\">";
				foreach ($value["language"] as $key2 => $value2) {
					$page_content = "$page_content<div align=\"left\"><a href=\"./index.php?page_id=8&amp;edit_id={$value["id"]}&amp;edit_language=$value2\">{$value["title"][$key2]}</a></div>";
				}
				$page_content = "$page_content</td><td style=\"text-align: center; background-color: {$bgarray[1]};\">";
				foreach ($value["language"] as $key2 => $value2) {
					$page_content = "$page_content<div><a href=\"./index.php?page_id=8&amp;edit_id={$value["id"]}&amp;edit_language=$value2\">[{$value2}]</a></div>";
				}
				$page_content = "$page_content<td style=\"background-color: {$bgarray[1]}; text-align: right;\"><div>
					<a href=\"./index.php?page_id=7&amp;language=$language&amp;action=delete&amp;menu_id={$value['id']}\" class=\"command\">[" . i18n("Delete") . "]</a>
					<a href=\"./index.php?page_id=7&amp;language=$language&amp;action=assign&amp;menu_id={$value["id"]}\" class=\"command\">[" . i18n("Assign") . "]</a>
					</div></td></tr>";
			} else {
				$page_content = "$page_content
				<tr><td style=\"background-color: {$bgarray[1]};\"><div>{$value["id"]}</div></td><td style=\"background-color: {$bgarray[1]};\"><div align=\"left\"><a href=\"./index.php?page_id=7&amp;edit_id={$value["id"]}&amp;edit_language={$value["language"]}\">{$value["title"]}</a></div></td><td style=\"background-color: {$bgarray[1]};\"><div>[{$value["language"]}]</div></td><td style=\"background-color: {$bgarray[1]}; text-align: right;\"><div>
					<a href=\"./index.php?page_id=7&amp;language=$language&amp;action=assign&amp;menu_id={$value["id"]}&amp;menu_language={$value["language"]}\" class=\"command\">[" . i18n("Assign") . "]</a>
				</div></td></tr>";
			}
		}
		
		$page_content = "$page_content
			</td></tr></table>
		</td></tr></table>";
	}
}
?>
