<?PHP
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * This file is part of Uberghey CMS
 *              A content management system with modules, based on wiki syntax
 *
 * Author: Dan Jensen <admin@leinir.dk>
 * Copyright 2003/2004
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License is available at: http://www.gnu.org/copyleft/
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

$page_author = $owner_name;
$page_author_email = $owner_email;
$page_date = "21/10/2003, 19:34";

if (file_exists("$setup_folder/profile_options.php")) $profile_options = file_get_contents("$setup_folder/profile_options.php");
$profile_options = unserialize($profile_options);

$page_menu = $profile_options["profiles_menu"];

$tabwidget = new TabWidget;

if ($_REQUEST["user_id"] == currentUser() || isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("My page"), siteURL() . "?page_id=13&amp;profile_mode=mypage&amp;user_id=" . $_REQUEST["user_id"]);
$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
foreach ($profilemodules as $key => $value) {
	$tabwidget->tabbar->addTab(i18n(substr($value, 14)), siteURL() . "?page_id=13&amp;profile_mode=module&amp;module=$value&amp;user_id=" . $_REQUEST["user_id"]);
}
$tabwidget->tabbar->addTab(i18n("Contact"), siteURL() . "?page_id=13&amp;profile_mode=contact&amp;user_id=" . $_REQUEST["user_id"]);
if (isAllowed("global_user_edit") || ($_REQUEST["user_id"] != "" && $_REQUEST["user_id"] == $_SESSION[$_SERVER["PHP_SELF"]]["login"])) $tabwidget->tabbar->addTab(i18n("Edit"), siteURL() . "?page_id=13&amp;profile_mode=edit&amp;user_id=" . $_REQUEST["user_id"]);

if ($_REQUEST["module"] != "") $_REQUEST["profile_mode"] = "module";

switch ($_REQUEST["profile_mode"]) {
case "new":
	$page_title = i18n("Register a new user");
	if (!isAllowed("global_user_new")) {
		$page_content = i18n("You do not have the correct priviledges to create a new user.");
	} else if (	$_REQUEST["new_username"] != "" && !strpos($_REQUEST["new_username"], " ") && strtolower($_REQUEST["new_username"]) == $_REQUEST["new_username"] && !$usermanager->userExists($_REQUEST["new_username"]) &&
			$_REQUEST["new_password"] != "" && $_REQUEST["new_password2"] != "" && ($_REQUEST["new_password"] == $_REQUEST["new_password2"]) && 
			$_REQUEST["new_fullname"] != "" && 
			$_REQUEST["new_email"] != "" && validateEmail($_REQUEST["new_email"]))
		{
		$usermanager->changeadd($_REQUEST["new_username"], $_REQUEST["new_password"], "setup/password.txt");
		saveUserInfo($_REQUEST["new_username"], "name", $_REQUEST["new_fullname"]);
		saveUserInfo($_REQUEST["new_username"], "email", $_REQUEST["new_email"]);
		auth($_REQUEST['new_username'], $_REQUEST['new_password']);
		header("Location: ./index.php?page_id=13&user_id={$_REQUEST['new_username']}&profile_mode=edit");
	} else {
		if (strpos($_REQUEST["new_username"], " ")) $username_errormessage = i18n("Your username cannot contain spaces");
		if (strtolower($_REQUEST["new_username"]) != $_REQUEST["new_username"]) $username_errormessage = i18n("Your username must be all lower case");
		if ($usermanager->userExists($_REQUEST["new_username"])) $username_errormessage = i18n("A user already exists with this login");
		if ($_REQUEST["new_password"] != $_REQUEST["new_password2"]) $password_errormessage = i18n("The passwords do not match!");
		if (!validateEmail($_REQUEST["new_email"]) && $_REQUEST["new_email"] != "") $email_errormessage = i18n("Your email address is not valid");
		
		if ($_REQUEST["new_username"] == "") $username_errormessage = i18n("You must fill in all fields");
		if ($_REQUEST["new_password"] == "") $password_errormessage = i18n("You must fill in all fields");
		if ($_REQUEST["new_fullname"] == "") $fullname_errormessage = i18n("You must fill in all fields");
		if ($_REQUEST["new_email"] == "") $email_errormessage = i18n("You must fill in all fields");
		
		$page_content = "
		<form action=\"./index.php?page_id=13&amp;profile_mode=new\" method=\"post\">
		<table class=\"setuptable user_register\">
		<tr class=\"user_register\">
		<td colspan=\"2\" class=\"user_register\"><div >" . i18n("Please type in the login information you wish to use in the fields bellow.") . "</div ></td>
		</tr><tr class=\"user_register\">
			<td width=\"45%\" class=\"user_register\">
				" . i18n("Username") . ":<span class=\"error\">$username_errormessage</span><br />
				<small class=\"comment\">" . i18n("All lower case, no spaces or special characters, for example johndoe") . "</small>
			</td>
			<td width=\"55%\" class=\"user_register\">
				<input class=\"user_register\" style=\"width: 100%\" type=\"text\" name=\"new_username\" value=\"{$_REQUEST['new_username']}\" />
			</td>
		</tr><tr class=\"user_register\">
			<td class=\"user_register\">
				" . i18n("Password") . ":<span class=\"error\">$password_errormessage</span><br />
				<small class=\"comment\">" . i18n("A password, at least 8 characters long. Repeat the password in the two boxes. Preferably comprised of a mix of upper and lower case characters and numbers, for example ##0##", array(makeRandomPassword())) . "</small>
			</td>
			<td class=\"user_register\">
				<input class=\"user_register\" style=\"width: 100%\" type=\"password\" name=\"new_password\" value=\"{$_REQUEST['new_password']}\" />
				<input class=\"user_register\" style=\"width: 100%\" type=\"password\" name=\"new_password2\" value=\"{$_REQUEST['new_password2']}\" />
			</td>
		</tr><tr class=\"user_register\">
			<td class=\"user_register\">
				" . i18n("Full name") . ":<span class=\"error\">$fullname_errormessage</span><br />
				<small class=\"comment\">" . i18n("Your full name, for example John Doe") . "</small>
			</td>
			<td class=\"user_register\">
				<input class=\"user_register\" style=\"width: 100%\" type=\"text\" name=\"new_fullname\" value=\"{$_REQUEST['new_fullname']}\" />
			</td>
		</tr>
		<tr class=\"user_register\">
			<td class=\"user_register\">
				" . i18n("Email address") . ":<span class=\"error\">$email_errormessage</span><br />
				<small class=\"comment\">" . i18n("The email address you wish to use, for example johndoe@site.com") . "</small>
			</td>
			<td class=\"user_register\">
				<input class=\"user_register\" style=\"width: 100%\" type=\"text\" name=\"new_email\" value=\"{$_REQUEST['new_email']}\" />
			</td>
		</tr><tr class=\"user_register\">
			<td class=\"user_register\"><input type=\"submit\" value=\"" . i18n("Register and log in") . "\" /></td>
			<td class=\"user_register wikirightalign\"><input type=\"reset\" value=\"" . i18n("Reset") . "\" /></td>
		</tr>
		</table>
		</form>
		";
	}
	break;
case "module":
	if ($usermanager->userExists($_REQUEST["user_id"])) {
		$page_title = i18n("##0##'s ##1##", array(getUserInfo($_REQUEST["user_id"], "name"), i18n(substr($_REQUEST["module"], 14))));
		$tabwidget->tabbar->setCurrent(i18n(substr($_REQUEST["module"], 14)));
		if (!userAllowsView($_REQUEST["user_id"])) {
			global $permissionlevels_array;
			$tabwidget->contents = "<p>" . i18n("The user has decided you are not allowed to view this page. The user has selected that only the following people can view their profile") . ":<br /><b>" . $permissionlevels_array[getUserInfo($_REQUEST["user_id"], "profiles_view")] . "</b></p>";
		} else {
			$tabwidget->contents = $_REQUEST["module"]();
		}
	} else {
		$page_title = i18n("##0##'s profile", array(i18n("Unknown User")));
		$tabwidget = new TabWidget;
		$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
		$tabwidget->tabbar->setCurrent(i18n("View"));
		if (isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("Add this user"), "./index.php?page_id=4&amp;action=add&amp;newusername=" . $_REQUEST["user_id"]);
		$tabwidget->contents = "<p>" . i18n("The user was not found on the system") . "</p>";
	}
	if ($_REQUEST["theme"] == "empty") {
		$page_content = $tabwidget->contents;
	} else {
		$page_content = $tabwidget->renderTabWidget();
	}
	break;
case "edit":
	if ($usermanager->userExists($_REQUEST["user_id"])) {
		include("profiles_edit.php");
	} else {
		$page_title = i18n("##0##'s profile", array(i18n("Unknown User")));
		$tabwidget = new TabWidget;
		$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
		$tabwidget->tabbar->setCurrent(i18n("View"));
		if (isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("Add this user"), "./index.php?page_id=4&amp;action=add&amp;newusername=" . $_REQUEST["user_id"]);
		$tabwidget->contents = "<p>" . i18n("The user was not found on the system") . "</p>";
		$page_content = $tabwidget->renderTabWidget();
	}
	break;
case "contact":
	if ($usermanager->userExists($_REQUEST["user_id"])) {
		$page_title = i18n("Contact ##0##", array(getUserInfo($_REQUEST["user_id"], "name")));
		$tabwidget->tabbar->setCurrent(i18n("Contact"));
		if (!userAllowsContact($_REQUEST["user_id"])) {
			global $permissionlevels_array;
			$tabwidget->contents = "<p>" . i18n("The user has decided you are not allowed to view this page. The user has selected that only the following people can contact them") . ":<br /><b>" . $permissionlevels_array[getUserInfo($_REQUEST["user_id"], "profiles_contact")] . "</b></p>";
		} else {
			$tabwidget->contents = "
			<h2>" . i18n("Contact information") . "</h2>";
			
			if ($_REQUEST["send_email"]) {
				if ($_REQUEST["email"] != "" && validateEmail($_REQUEST["email"]) && $_REQUEST["subject"] != "" && $_REQUEST["message"] != "") {
					if (!$_SESSION["email_sent_time"] OR (time() - $_SESSION["email_sent_time"]) > 15) {
						if (mail(getUserInfo($_REQUEST["user_id"], "email"), $_REQUEST["subject"], $_REQUEST["message"], "From: " . $_REQUEST["email"] . "\r\n" . "X-Mailer: PHP/" . phpversion())) { 
							$_SESSION["email_sent_time"] = time();
							$tabwidget->contents .= "<tr><td colspan=\"2\"><strong>" . i18n("The email was sent successfully!") . "</strong><hr /></td></tr>";
						} else {
							$tabwidget->contents .= "<tr><td colspan=\"2\"><strong>" . i18n("An error occured while attempting to send the email! This probably means that the server does not support sending emails, or that there is a mis-configuration.") . "</strong><hr /></td></tr>";
						}
					} else {
						$tabwidget->contents .= "<tr><td colspan=\"2\"><strong>" . i18n("You have attempted to send another email before 15 seconds passed since the last message was sent.") . "</strong><hr /></td></tr>";
					}
				} else {
					if (!validateEmail($_REQUEST["email"])) {
						$tabwidget->contents .= "<tr><td colspan=\"2\"><strong>" . i18n("The email address was filled in wrongly! Please correct this and try again.") . "</strong><hr /></td></tr>";
					} else {
						$tabwidget->contents .= "<tr><td colspan=\"2\"><strong>" . i18n("All fields were not filled out! Please correct this and try again.") . "</strong><hr /></td></tr>";
					}
				}
			}
			
			$tabwidget->contents .= "
			<table width=\"100%\">
			<tr>
				<th width=\"50%\">" . i18n("Contact type and description") . "</th>
				<th width=\"50%\">" . i18n("Contact detail (click on icon to activate)") . "</th>
			</tr>";
			
			$contactinfo = unserialize(getUserInfo($_REQUEST['user_id'], "contactinfo"));
			if (is_array($contactinfo)) {
			foreach($contactinfo as $key => $value) {
				if ($value) {
				$url = str_replace("$$", $value, $profile_options["contact_fields"][$key]["url"]);
				$contact_content .= "
				<tr><td>
					<p class=\"profile_contactitem\">$key:<br /><small class=\"comment\">" . $profile_options["contact_fields"][$key]["description"] . "</small></p>
				</td><td>
					<a href=\"$url\" target=\"_blank\" title=\"" . $value . "\"><img border=\"0\" class=\"profile_contactimage\" src=\"$setup_folder/images/contact/" . $profile_options["contact_fields"][$key]["image"] . "\" alt=\"" . $value . "\" /></a>
					<p class=\"profile_contactitem\">$value</p>
				</td></tr>";
				}
			}
			}
			if ($contact_content == "") $contact_content = "<tr><td colspan=\"2\"><p><em>" . i18n("No contact information") . "</em></p></td></tr>";
			$tabwidget->contents .= "$contact_content
			</table>
			<h2>" . i18n("Email") . "</h2>
			<p>" . i18n("Please note, that you can only send one email from this website to any user every 15 (fifteen) seconds. This is done to protect against using the website for spamming or other malicious purposes. Thank you for your understanding.") . "</p>
			<form action=\"./index.php?page_id=13&amp;profile_mode=contact&amp;user_id=" . $_REQUEST["user_id"] . "\" method=\"post\">
			<table width=\"100%\">
			<tr>
				<td width=\"35%\">
					" . i18n("From") . ":<br />
					<small class=\"comment\">" . i18n("Your email, in the following format: johndoe@somesite.com") . "</small>
				</td>
				<td width=\"65%\"><input style=\"width: 100%\" type=\"text\" name=\"email\" value=\"{$_REQUEST['email']}\" /></td>
			</tr>
			<tr>
				<td width=\"35%\">
					" . i18n("Subject") . ":<br />
					<small class=\"comment\">" . i18n("The subject of the message") . "</small>
				</td>
				<td width=\"65%\"><input style=\"width: 100%\" type=\"text\" name=\"subject\" value=\"{$_REQUEST['subject']}\" /></td>
			</tr>
			<tr>
				<td colspan=\"2\"><textarea rows=\"10\" cols=\"70\" style=\"width: 100%\" name=\"message\">{$_REQUEST['message']}</textarea>
				</td>
			</tr>
			<tr>
				<td colspan=\"2\">
				<div class=\"wikicenteralign\">
					<input type=\"submit\" name=\"send_email\" value=\"" . i18n("Send email") . "\" />
					<input type=\"reset\" value=\"" . i18n("Reset") . "\" />
				</div>
				</td>
			</tr>
			</table>
			</form>
			";
		}
	} else {
		$page_title = i18n("##0##'s profile", array(i18n("Unknown User")));
		$tabwidget = new TabWidget;
		$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
		$tabwidget->tabbar->setCurrent(i18n("View"));
		if (isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("Add this user"), "./index.php?page_id=4&amp;action=add&amp;newusername=" . $_REQUEST["user_id"]);
		$tabwidget->contents = "<p>" . i18n("The user was not found on the system") . "</p>";
	}
	$page_content = $tabwidget->renderTabWidget();
	break;
case "mypage":
	$page_title = i18n("My page") . " - " . getUserInfo($_REQUEST["user_id"], "name");
	$tabwidget->tabbar->setCurrent(i18n("My page"));
	$currentuser = $_SESSION[$_SERVER["PHP_SELF"]]["login"];
	if ($usermanager->userExists($_REQUEST["user_id"])) {
		if ($_REQUEST["user_id"] == $currentuser || userAllowsMypage($_REQUEST["user_id"])) {
			if (($_REQUEST["user_id"] == $currentuser || isAllowed("global_admin")) && ($_REQUEST["new_relationship"] == "neutral" && $usermanager->userExists($_REQUEST["changeuser"]))) {
				setFriend($_REQUEST["user_id"], $_REQUEST["changeuser"], false);
				setBlacklisted($_REQUEST["user_id"], $_REQUEST["changeuser"], false);
			}
		
			$filename = "$userinfo_folder/{$_REQUEST["user_id"]}/relationships.php";
			if (file_exists($filename)) $relationships = file_get_contents($filename);
			$relationships = unserialize(substr($relationships, strpos($relationships, "\n") + 1));
			
			
			if (count($relationships["friends"]) > 0) {
				ksort($relationships["friends"]);
				foreach($relationships["friends"] as $key => $value) {
					if (file_exists("$userinfo_folder/$key/avatar.jpg")) {
						$avatarfile = "$userinfo_folder/$key/avatar.jpg";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.jpg";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else if (file_exists("$userinfo_folder/$key/avatar.png")) {
						$avatarfile = "$userinfo_folder/$key/avatar.png";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.png";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else if (file_exists("$userinfo_folder/$key/avatar.gif")) {
						$avatarfile = "$userinfo_folder/$key/avatar.gif";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.gif";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else {
						$avatarthumbfile = "$setup_folder/images/noavatar.png";
						$avatarfile = $avatarthumbfile;
						$avatarwidth = 64;$avatarheight = 64;
					}
					$temp_friends_data = "
					<tr>
						<td><a href=\"$avatarfile\" target=\"_blank\"><img border=\"0\" class=\"profile_avatar\" src=\"$avatarthumbfile\" width=\"$avatarwidth\" height=\"$avatarheight\" alt=\"" . i18n("##0##'s avatar", array(getUserInfo($key, "name"))) . "\" /></a>
						<strong>" . getUserInfo($key, "name") . " ($key)</strong><br />";
						if (userAllowsView($key)) $temp_friends_data .= "<a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=view&amp;user_id=$key\">[" . i18n("View profile") . "]</a><br />";
						if (userAllowsContact($key)) $temp_friends_data .= "<a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=contact&amp;user_id=$key\">[" . i18n("Contact") . "]</a><br />";
					$temp_friends_data .= "<br /><a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=mypage&amp;user_id={$_REQUEST["user_id"]}&amp;changeuser=$key&amp;new_relationship=neutral\">[" . i18n("Remove from friends list") . "]</a>
						</td>
					</tr>";
					if (isFriend($key, $_REQUEST["user_id"])) $mutual_friends_data .= $temp_friends_data;
					else if (isBlacklisting($key, $_REQUEST["user_id"])) $black_friends_data .= $temp_friends_data;
					else $neutral_friends_data .= $temp_friends_data;
				}
				
				$friends_data = "
				<table width=\"100%\">
				";
				if ($mutual_friends_data != "") $friends_data .= "<th>" . i18n("Mutual friendships (I am marked as friend)") . "</th>$mutual_friends_data";
				if ($neutral_friends_data != "") $friends_data .= "<th>" . i18n("Friendships (I am  marked neutral)") . "</th>$neutral_friends_data";
				if ($black_friends_data != "") $friends_data .= "<th>" . i18n("One-way friendships (I am blacklisted)") . "</th>$black_friends_data";
				$friends_data .= "
				</table>";
			}
			
			if (count($relationships["blacklists"]) > 0) {
				ksort($relationships["blacklists"]);
				foreach($relationships["blacklists"] as $key => $value) {
					if (file_exists("$userinfo_folder/$key/avatar.jpg")) {
						$avatarfile = "$userinfo_folder/$key/avatar.jpg";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.jpg";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else if (file_exists("$userinfo_folder/$key/avatar.png")) {
						$avatarfile = "$userinfo_folder/$key/avatar.png";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.png";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else if (file_exists("$userinfo_folder/$key/avatar.gif")) {
						$avatarfile = "$userinfo_folder/$key/avatar.gif";
						$avatarthumbfile = "$userinfo_folder/$key/avatar-thumb.gif";
						if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
						list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
					} else {
						$avatarthumbfile = "$setup_folder/images/noavatar.png";
						$avatarfile = $avatarthumbfile;
						$avatarwidth = 64;$avatarheight = 64;
					}
					$temp_blacklist_data .= "
					<tr>
						<td><a href=\"$avatarfile\" target=\"_blank\"><img border=\"0\" class=\"profile_avatar\" src=\"$avatarthumbfile\" width=\"$avatarwidth\" height=\"$avatarheight\" alt=\"" . i18n("##0##'s avatar", array(getUserInfo($key, "name"))) . "\" /></a>
						<strong>" . getUserInfo($key, "name") . " ($key)</strong><br />
						";
						if (userAllowsView($key)) $temp_blacklist_data .= "<a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=view&amp;user_id=$key\">[" . i18n("View profile") . "]</a><br />";
						if (userAllowsView($key)) $temp_blacklist_data .= "<a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=contact&amp;user_id=$key\">[" . i18n("Contact") . "]</a><br />";
					$temp_blacklist_data .= "<br /><a class=\"command\" href=\"./index.php?page_id=13&amp;profile_mode=mypage&amp;user_id={$_REQUEST["user_id"]}&amp;changeuser=$key&amp;new_relationship=neutral\">[" . i18n("Remove from blacklist") . "]</a>
						</td>
					</tr>";
					if (isFriend($key, $_REQUEST["user_id"])) $friend_blacklist_data .= $temp_blacklist_data;
					else if (isBlacklisting($key, $_REQUEST["user_id"])) $mutual_blacklist_data .= $temp_blacklist_data;
					else $neutral_blacklist_data .= $temp_blacklist_data;
				}
				$blacklist_data .= "
				<table width=\"100%\">
				";
				if ($friend_blacklist_data != "") $blacklist_data .= "<th>" . i18n("Friendly towards me (I am marked as friend)") . "</th>$friend_blacklist_data";
				if ($neutral_blacklist_data != "") $blacklist_data .= "<th>" . i18n("Neutral blacklisting (I am marked as neutral)") . "</th>$neutral_blacklist_data";
				if ($mutual_blacklist_data != "") $blacklist_data .= "<th>" . i18n("Mutual blacklisting (I am blacklisted)") . "</th>$mutual_blacklist_data";
				$blacklist_data .= "
				</table>";
			}
			
			if ($friends_data == "" && $blacklist_data == "") $tabwidget->contents = "<p><em><strong>" . i18n("Welcome to your page!") . "</strong></em></p><p>" . i18n("This is your personal page. If you select people as friends or if you blacklist people, they will show up here. You can use this as a shortcut list for keeping track of people you like, or for don't like. Options for contacting them in various manners will show up here") . "</p>";
			if ($friends_data == "") $friends_data = "<p class=\"comment\">" . i18n("You have not yet found any friends on this website. You can set a person as a friend by clicking on the Friends button on a user's profile") . "</p>";
			if ($blacklist_data == "") $blacklist_data = "<p class=\"comment\">" . i18n("You have not blacklisted anyone. You can blacklist someone by clicking on the Blacklist button on a user's profile") . "</p>";
			$tabwidget->contents .= "
			<table width=\"100%\" class=\"setup\">
			<tr class=\"setup\">
				<th width=\"50%\">" . i18n("My friends") . "</th>
				<th width=\"50%\">" . i18n("My blacklist") . "</th>
			<tr>
			<tr class=\"setup\">
				<td valign=\"top\">$friends_data</td>
				<td valign=\"top\">$blacklist_data</td>
			</tr>
			</table>";
			
		}
	} else {
		$page_title = i18n("##0##'s profile", array(i18n("Unknown User")));
		$tabwidget = new TabWidget;
		$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
		$tabwidget->tabbar->setCurrent(i18n("View"));
		if (isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("Add this user"), "./index.php?page_id=4&amp;action=add&amp;newusername=" . $_REQUEST["user_id"]);
		$tabwidget->contents = "<p>" . i18n("The user was not found on the system") . "</p>";
	}
	$page_content = $tabwidget->renderTabWidget();
	break;
case "view":
default:
	$page_title = i18n("##0##'s Profile", array(getUserInfo($_REQUEST["user_id"], "name")));
	$tabwidget->tabbar->setCurrent(i18n("View"));
	if (!userAllowsView($_REQUEST["user_id"])) {
		global $permissionlevels_array;
		$tabwidget->contents = "<p>" . i18n("The user has decided you are not allowed to view this page. The user has selected that only the following people can view their profile") . ":<br /><b>" . $permissionlevels_array[getUserInfo($_REQUEST["user_id"], "profiles_view")] . "</b></p>";
	} else {
		if ($usermanager->userExists($_REQUEST["user_id"])) {
			if (file_exists("$userinfo_folder/{$_REQUEST['user_id']}/avatar.jpg")) {
				$avatarfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar.jpg";
				$avatarthumbfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar-thumb.jpg";
				if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
				list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
			} else if (file_exists("$userinfo_folder/{$_REQUEST['user_id']}/avatar.png")) {
				$avatarfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar.png";
				$avatarthumbfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar-thumb.png";
				if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
				list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
			} else if (file_exists("$userinfo_folder/{$_REQUEST['user_id']}/avatar.gif")) {
				$avatarfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar.gif";
				$avatarthumbfile = "$userinfo_folder/{$_REQUEST['user_id']}/avatar-thumb.gif";
				if (!file_exists($avatarthumbfile)) $avatarthumbfile = $avatarfile;
				list($avatarwidth,$avatarheight) = getimagesize($avatarthumbfile);
			} else {
				$avatarthumbfile = "$setup_folder/images/noavatar.png";
				$avatarfile = $avatarthumbfile;
				$avatarwidth = 64;$avatarheight = 64;
			}
			$tabwidget->contents = "<a href=\"$avatarfile\" target=\"_blank\"><img border=\"0\" class=\"profile_avatar\" src=\"$avatarthumbfile\" width=\"$avatarwidth\" height=\"$avatarheight\" alt=\"" . i18n("##0##'s avatar", array(getUserInfo($_REQUEST["user_id"], "name"))) . "\" /></a>" . parse_page_data(getUserInfo($_REQUEST["user_id"], "profile"));
			if (isAuth() && ($_REQUEST["user_id"] != $_SESSION[$_SERVER["PHP_SELF"]]["login"])) {
				if ($_REQUEST["new_relationship"] != "") {
					switch ($_REQUEST["new_relationship"]) {
					case "friend":
						setFriend($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], true);
						setBlacklisted($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], false);
						break;
					case "blacklist":
						setFriend($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], false);
						setBlacklisted($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], true);
						break;
					case "neutral":
					default:
						setFriend($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], false);
						setBlacklisted($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"], false);
						
					}
				}
				if (isFriend($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"])) {
					$tabwidget->addCommand(i18n("##0## Friend", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-on.png\" width=\"10\" height=\"10\" alt=\"x\" />")), i18n("This user is your friend!"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=friend");
					$tabwidget->addCommand(i18n("##0## Neutral", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as neutral"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=neutral");
					$tabwidget->addCommand(i18n("##0## Blacklisted", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as blacklisted"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=blacklist");
				} else if (isBlacklisting($_SESSION[$_SERVER["PHP_SELF"]]["login"], $_REQUEST["user_id"])) {
					$tabwidget->addCommand(i18n("##0## Friend", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as your friend"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=friend");
					$tabwidget->addCommand(i18n("##0## Neutral", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as neutral"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=neutral");
					$tabwidget->addCommand(i18n("##0## Blacklisted", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-on.png\" width=\"10\" height=\"10\" alt=\"x\" />")), i18n("You have blacklisted this user"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=blacklist");
				} else {
					$tabwidget->addCommand(i18n("##0## Friend", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as your friend"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=friend");
					$tabwidget->addCommand(i18n("##0## Neutral", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-on.png\" width=\"10\" height=\"10\" alt=\"x\" />")), i18n("This user is neutral to you"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=neutral");
					$tabwidget->addCommand(i18n("##0## Blacklisted", array("<img style=\"vertical-align: middle;\" border=\"0\" src=\"$setup_folder/images/selection-off.png\" width=\"10\" height=\"10\" alt=\"o\" />")), i18n("Set this user as blacklisted"), siteURL() . "?page_id=13&amp;user_id={$_REQUEST['user_id']}&amp;new_relationship=blacklist");
				}
			}
		} else {
			$tabwidget = new TabWidget;
			$tabwidget->tabbar->addTab(i18n("View"), siteURL() . "?page_id=13&amp;profile_mode=view&amp;user_id=" . $_REQUEST["user_id"]);
			$tabwidget->tabbar->setCurrent(i18n("View"));
			if (isAllowed("global_admin")) $tabwidget->tabbar->addTab(i18n("Add this user"), "./index.php?page_id=4&amp;action=add&amp;newusername=" . $_REQUEST["user_id"]);
			$tabwidget->contents = "<p>" . i18n("The user was not found on the system") . "</p>";
		}
	}
	$page_content = $tabwidget->renderTabWidget();
}


?>
